{$A+,B-,D-,F-,G+,I-,K+,L-,N-,P-,Q-,R-,S+,T-,V-,W-,X+,Y- }
library OpenAny;
{
  Dll OpenAny Expert

  Author:  Jurg_van_Vliet
  Created: 23/12/96
  
  This Expert opens any ascii file in the delphi ide.
  Copyright OEC Nederland BV
}

uses
  ShareMem, SysUtils, Windows, Classes, Forms, ExptIntf, ToolIntf, Dialogs;

type
  TOpenAnyExpert = class(TIExpert)
  protected
    procedure OnClick( Sender: TIMenuItemIntf); virtual;
  public
    constructor Create; virtual;
    destructor Destroy; override;
    function GetName: string; override;
    function GetAuthor: string; override;
    function GetStyle: TExpertStyle; override;
    function GetIDString: string; override;
  end;

const
  MenuItem: TIMenuItemIntf = nil;

procedure HandleException;
begin
  if assigned(ToolServices) then
    ToolServices.RaiseException(ReleaseException)
end;

constructor TOpenAnyExpert.Create;
var
  Main: TIMainMenuIntf;
  ReferenceMenuItem: TIMenuItemIntf;
  Menu: TIMenuItemIntf;
begin
  try
    inherited Create;
    MenuItem := nil;
    if ToolServices <> nil then begin { I'm an expert! }
      Main := ToolServices.GetMainMenu;
      if Main <> nil then begin { we've got the main menu! }
        try 
          { add the menu of your choice }
          ReferenceMenuItem := Main.FindMenuItem('FileOpenItem');
          if ReferenceMenuItem <> nil then
          try
            Menu := ReferenceMenuItem.GetParent;
            if Menu <> nil then
            try
              MenuItem := Menu.InsertItem(ReferenceMenuItem.GetIndex+1,
                                'OpenAny',
                                'OpenAnyExpertItem','',
                                0,0,0,
                                [mfEnabled, mfVisible], OnClick);
            finally
              Menu.DestroyMenuItem;
            end;
          finally
            ReferenceMenuItem.DestroyMenuItem;
          end;
        finally
          Main.Free;
        end;
      end;
    end;
  except
    HandleException
  end;
end;

destructor TOpenAnyExpert.Destroy;
begin
  try
    if MenuItem <> nil then
      MenuItem.DestroyMenuItem;
    inherited Destroy;
  except
    HandleException
  end;
end;

{ TOpenAnyExpert code }
function TOpenAnyExpert.GetName: String;
begin
  try
    Result := 'OpenAnyExpert'
  except
    HandleException
  end;
end;

function TOpenAnyExpert.GetAuthor: String;
begin
  try
    Result := 'Jurg_van_Vliet'; { author }
  except
    HandleException
  end;
end;

function TOpenAnyExpert.GetStyle: TExpertStyle;
begin
  try
    Result := esAddIn;
  except
    HandleException
  end;
end;

function TOpenAnyExpert.GetIDString: String;
begin
  try
    Result := 'Oec_Nederland.OpenAnyExpert';
  except
    HandleException
  end;
end;

procedure TOpenAnyExpert.OnClick( Sender: TIMenuItemIntf);
begin
  try
    with TOpendialog.Create( application) do
      if Execute then
        if ToolServices <> nil then
          ToolServices.OpenFile( FileName)
  except
    HandleException
  end;
end;

procedure DoneExpert;
begin
  MenuItem.DestroyMenuItem;
end;

function InitExpert( ToolServices: TIToolServices;
                     RegisterProc: TExpertRegisterProc;
                 var Terminate: TExpertTerminateProc): boolean; stdcall;
begin
  Result := ToolServices <> nil;
  if Result then begin
    ExptIntf.ToolServices := ToolServices;
    Terminate := DoneExpert;
    Application.Handle := ToolServices.GetParentHandle;
    Result := RegisterProc(TOpenAnyExpert.Create);
  end;
end;

exports
  InitExpert name ExpertEntryPoint resident;

begin
end.
