unit OpenAny;
{
  Vcl OpenAny Expert

  Author:  Jurg_van_Vliet
  Created: 23/12/96

  This Expert open any ascii ifl ein the delphi ide.
  Copyright OEC Nederland BV
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExptIntf, ToolIntf;

type
  TOpenAnyExpert = class(TIExpert)
  private
    MenuItem: TIMenuItemIntf;
  protected
    procedure OnClick( Sender: TIMenuItemIntf); virtual;
  public
    constructor Create; virtual;
    destructor Destroy; override;
    function GetName: string; override;
    function GetAuthor: string; override;
    function GetStyle: TExpertStyle; override;
    function GetIDString: string; override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterLibraryExpert(TOpenAnyExpert.Create);
end;

{ TOpenAnyExpert code }
function TOpenAnyExpert.GetName: String;
begin
  Result := 'OpenAnyExpert'
end;

function TOpenAnyExpert.GetAuthor: String;
begin
  Result := 'Jurg_van_Vliet'; { author }
end;

function TOpenAnyExpert.GetStyle: TExpertStyle;
begin
  Result := esAddIn;
end;

function TOpenAnyExpert.GetIDString: String;
begin
  Result := 'Oec_Nederland.OpenAnyExpert';
end;

constructor TOpenAnyExpert.Create;
var
  Main: TIMainMenuIntf;
  ReferenceMenuItem: TIMenuItemIntf;
  Menu: TIMenuItemIntf;
begin
  inherited Create;
  MenuItem := nil;
  if ToolServices <> nil then begin { I'm an expert! }
    Main := ToolServices.GetMainMenu;
    if Main <> nil then begin { we've got the main menu! }
      try 
        { add the menu of your choice }
        ReferenceMenuItem := Main.FindMenuItem('FileOpenItem');
        if ReferenceMenuItem <> nil then
        try
          Menu := ReferenceMenuItem.GetParent;
          if Menu <> nil then
          try
            MenuItem := Menu.InsertItem(ReferenceMenuItem.GetIndex+1,
                              'OpenAny',
                              'OpenAnyExpertItem','',
                              0,0,0,
                              [mfEnabled, mfVisible], OnClick);
          finally
            Menu.DestroyMenuItem;
          end;
        finally
          ReferenceMenuItem.DestroyMenuItem;
        end;
      finally
        Main.Free;
      end;
    end;
  end;
end;

destructor TOpenAnyExpert.Destroy;
begin
  if MenuItem <> nil then
    MenuItem.DestroyMenuItem;
  inherited Destroy;
end;{Destroy}

procedure TOpenAnyExpert.OnClick( Sender: TIMenuItemIntf);
begin
  with TOpendialog.Create( application) do
    if Execute then
      if ToolServices <> nil then
        ToolServices.OpenFile( FileName)
end;

end.